RM:=rm
MAKE:=make
CXX:=g++

CXXFLAGS:=-Wall -std=c++11 -DNDEBUG -g
MAKEDEP:=$(CXX) $(CXXFLAGS) -M

OBJS:=gc.o
LIB:=libmaxxgc.a

TEST_OBJS:=test.o

ALL_OBJS:=$(OBJS) $(TEST_OBJS)

DEPS:=$(patsubst %.o,.%.dep,$(ALL_OBJS))

# WTF doesn't it work as .PHONY? (TODO)
#.PHONY: clean distclean $(SUBPROJECTS_DEPS) $(SUBPROJECTS_CLEAN) $(SUBPROJECTS_DISTCLEAN)

default: $(LIB)

-include $(DEPS)

%.o: %.cc .%.dep
	$(CXX) $(CXXFLAGS) -c -o $@ $<

$(LIB): $(OBJS)
	$(AR) rcs $@ $(OBJS)

%_clean:
	$(MAKE) -C $(patsubst %_clean,%,$@) clean

clean:
	$(RM) -vf $(ALL_OBJS) $(LIB) test

distclean: clean
	$(RM) -vf $(DEPS)

dep:
	$(MAKE) -f Makefile.dep realdep

test: $(TEST_OBJS) $(LIB)
	$(CXX) $(CXXFLAGS) -o $@ $< $(LIB)
